/***************************************************************************
**
**  This file is part of QGpCoreWave.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This file is distributed in the hope that it will be useful, but WITHOUT
**  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
**  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
**  License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2010-06-15
**  Copyright: 2010-2019
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#ifndef GEOPHYSICALMODEL_H
#define GEOPHYSICALMODEL_H

#include <QGpCoreTools.h>

#include "QGpCoreWaveDLLExport.h"

namespace QGpCoreWave {

class QGPCOREWAVE_EXPORT GeophysicalModel
{
public:
  GeophysicalModel() {}
  virtual ~GeophysicalModel() {}

  virtual GeophysicalModel * clone() const=0;

  virtual QString toString() const=0;
  virtual bool fromStream(QTextStream& s, QString * comments=0)=0;
  virtual void toStream(QTextStream& s) const=0;

  virtual bool isEmpty() const=0;
  virtual bool isValid() {return true;}

  class GeophysicalContext : public ExpressionContext
  {
  public:
    void setModel(GeophysicalModel * m) {_model=m;}
    GeophysicalModel * model() const {return _model;}
    virtual QString helpCode() const=0;
  protected:
    GeophysicalModel * _model;
  };

  virtual GeophysicalContext * expressionContext() const=0;

  static QString allFormatHelp();
};

} // namespace QGpCoreWave

#endif // GEOPHYSICALMODEL_H
